<?

// script created by eedomus on march 2016
// you are free to modify it

// change define('DEBUG') value to get more verbose output
function sdk_orvibo_debug($str)
{
	if (DEBUG)
	{
		echo $str."<br>";
	}
}

// build payload
function sdk_make_payload($data) 
{
	$res = '';
	foreach($data as $v) 
	{
		$res .= chr($v);
	}
	return $res;
}

// convert an hex string to an array
function sdk_hex_string_to_array($buf) 
{
	$res = array();
	for($i = 0; $i < strlen($buf) - 1; $i += 2) 
	{
		$res[] = (hexdec($buf[$i].$buf[$i+1]));
	}
	return $res;   
}

// convert binary data to an hex string
function sdk_binary_to_string($buf) 
{
  $res = '';
  for($i = 0; $i < strlen($buf); $i++) 
  {
    $num = dechex(ord($buf[$i]));
    if (strlen($num) == 1) 
    {
      $num = '0'.$num;
    }
    $res .= $num;
  }
  return $res;
}

// emit IR code on Orvibo AllOne
function sdk_emit_ir($sock, $code, $mac, $all_one_ip, $port)
{
  $code = trim(str_replace(' ', '', $code));
  $len1 = (int)(strlen($code) / 2) + 26;
  $high_byte = floor($len1 / 256);
  $low_byte = $len1 - $high_byte * 256;
  $h1 = dechex($high_byte);
  $l1 = dechex($low_byte);
  if (strlen($h1) < 2) 
  {
    $h1 = '0'.$h1;
  }
  if (strlen($l1) < 2) 
  {
    $l1 = '0'.$l1;
  }
  $packetlen = $h1.$l1;
	
  $len2 = strlen($code) / 2;
  $high_byte = floor($len2 / 256);
  $low_byte = $len2 - $high_byte * 256;
  $h2 = dechex($high_byte);
  $l2 = dechex($low_byte);
  if (strlen($h2) < 2) 
  {
    $h2 = '0'.$h2;
  }
  if (strlen($l2) < 2) 
  {
    $l2 = '0'.$l2;
  }
  $irlen = array_reverse(sdk_hex_string_to_array($h2.$l2));
  $randomBitA = rand(0, 255);
  $randomBitB = rand(0, 255);

  $payload  = sdk_make_payload(array(0x68, 0x64));
  $payload .= sdk_make_payload(sdk_hex_string_to_array($packetlen));
  $payload .= sdk_make_payload(array(0x69, 0x63));
  $payload .= sdk_make_payload(sdk_hex_string_to_array($mac));
  $payload .= sdk_make_payload($GLOBALS['twenties']);
  $payload .= sdk_make_payload(array(0x65, 0x00, 0x00, 0x00));
  $payload .= sdk_make_payload(array($randomBitA, $randomBitB));
  $payload .= sdk_make_payload($irlen);
  $payload .= sdk_make_payload(sdk_hex_string_to_array($code));

  $res = socket_sendto($sock, $payload, strlen($payload), 0, $all_one_ip, $port);
  sdk_orvibo_debug("[".strtoupper(chunk_split(sdk_binary_to_string($payload), 2, ' '))."] sent to $all_one_ip, $port\n");
}

// show an image on the page
function sdk_show_header()
{
	echo "<img src='https://secure.eedomus.com/img/mdm/periph/orvibo_allone.png'><br>";
}

// first available button value
function sdk_get_next_button()
{
	$button_id = 1;
	
	for ($i = 1; $i < 400; $i++)
	{
		$ir_code = loadVariable('button'.$i);
		if ($ir_code == '')
		{
			$button_id = $i;
			break;
		}
	}
		
	return $button_id;
}


$port = 10000; // The port we'll connect on
$GLOBALS['twenties'] = array(0x20, 0x20, 0x20, 0x20, 0x20, 0x20);
define('DEBUG', 0); // set to 1 to have more output print

$action = getArg('action');

if( !($sock = socket_create(AF_INET, SOCK_DGRAM, SOL_UDP)) )
{
	$errorcode = socket_last_error();
	$errormsg = socket_strerror($errorcode);
	die("Couldn't create socket: [$errorcode] $errormsg \n");
}

$bind_ip = "0.0.0.0"; // Bind the source address
if( !socket_bind($sock, $bind_ip, $port) )
{
	$errorcode = socket_last_error();
	$errormsg = socket_strerror($errorcode);
	die("Could not bind socket : [$errorcode] $errormsg \n");
}

sdk_orvibo_debug("Socket bind (".$bind_ip.":".$port.") OK \n");
socket_set_option($sock, SOL_SOCKET, SO_BROADCAST, 1);

switch ($action)
{
	case 'delete':
		$button_id = getArg('button_id');
		saveVariable('button'.$button_id, NULL);
	//break; // no break, we want to show setup page after deletion
	
	case 'setup':
		sdk_show_header();
		echo "Actual learned IR codes :<br><ul>";
		
		// 400 buttons maximum, change here if more needed
		for ($i = 1; $i < 400; $i++)
		{
			$ir_code = loadVariable('button'.$i);
			if ($ir_code != '')
			{
				$query_learn = $_GET;
				$query_learn['action'] = 'learn';
				$query_learn['button_id'] = $i;
				$learn_link = http_build_query($query_learn);
				
				$query_delete = $_GET;
				$query_delete['action'] = 'delete';
				$query_delete['button_id'] = $i;
				$delete_link = http_build_query($query_delete);
				
				$query_test = $_GET;
				$query_test['action'] = 'send';
				$query_test['button_id'] = $i;
				$test_link = http_build_query($query_test);
				
				echo "<li>Button $i - <a href='?$learn_link'>Learn again</a> - <a href='?$delete_link'>Delete</a> - <a href='?$test_link'>Test</a> </li>";
			}
		}
		echo "</ul>";
		
		$query = $_GET;
		$query['action'] = 'learn';
		$query['button_id'] = sdk_get_next_button();
		$query_string = http_build_query($query);
		
		echo "<a href='?".$query_string."'>Learn a new button</a>";
	break;

	case 'learn':
		sdk_show_header();
		echo "Orvibo is now in learn mode (LED is red), press the button you want on your IR remote.<br><br>";
		echo "(This page will timeout after 15 seconds)";
		
		$query = $_GET;
		$query['action'] = 'do_learn';
		$query_string = http_build_query($query);
		echo "<script>window.location.href = '?$query_string';</script>";
	break;
	
	case 'send':
		$mac = getArg('ORVIBO_MAC');
		$ip = getArg('ORVIBO_IP');
		$button_id = getArg('button_id');
		
		$code = loadVariable('button'.$button_id);
		if ($code != '')
		{
      sdk_subscribe($sock, $ip, $port); // Required action after connection to device before sending any requests
			sdk_emit_ir($sock, $code, $mac, $ip, $port);
		
			sdk_show_header();
			echo "IR code for button #$button_id sent<br><br>";
			
			$query = $_GET;
			$query['action'] = 'setup';
			$query_string = http_build_query($query);
			echo "<a href='?".$query_string."'>Setup</a>";
		}
		else
		{
			sdk_show_header();
			echo "IR code for button #$button_id is not set, press <b>Learn</b> to start<br><br>";
			
			$query = $_GET;
			$query['action'] = 'learn';
			$query_string = http_build_query($query);
			echo "<a href='?".$query_string."'>Learn</a>";
		}
		
	break;
	
	case 'do_learn':
		$mac = getArg('ORVIBO_MAC');
		$ip = getArg('ORVIBO_IP');
		
		sdk_subscribe($sock, $ip, $port);
		
		$payload  = sdk_make_payload(array(0x68, 0x64, 0x00, 0x18, 0x6c, 0x73));
		$payload .= sdk_make_payload(sdk_hex_string_to_array($mac));
		$payload .= sdk_make_payload($GLOBALS['twenties']);
		$payload .= sdk_make_payload(array(0x01, 0x00, 0x00, 0x00, 0x00, 0x00));
		
		$res = socket_sendto($sock, $payload, strlen($payload), 0, $ip, $port);
		sdk_orvibo_debug("[".strtoupper(chunk_split(sdk_binary_to_string($payload), 2, ' '))."] sent to $ip, $port\n");

		sdk_read_data($sock);
	break;
	
	case 'scan':
		$payload  = sdk_make_payload(array(0x68, 0x64, 0x00, 0x06, 0x71, 0x61));
		$ip = '255.255.255.255';
		$res = socket_sendto($sock, $payload, strlen($payload), 0, $ip, $port);
		sdk_orvibo_debug("[".strtoupper(chunk_split(sdk_binary_to_string($payload), 2, ' '))."] sent to $ip, $port\n");
		
		sdk_read_data($sock);
	break;
}

// subscribe to Orvibo messages
function sdk_subscribe($sock, $ip, $port)
{
	$macReversed = array_reverse(sdk_hex_string_to_array($GLOBALS['mac']));
	$payload = sdk_make_payload(array(0x68, 0x64, 0x00, 0x1e, 0x63, 0x6c)).sdk_make_payload(sdk_hex_string_to_array($GLOBALS['mac'])).sdk_make_payload($GLOBALS['twenties']).sdk_make_payload($macReversed).sdk_make_payload($GLOBALS['twenties']);
	$res = socket_sendto($sock, $payload, strlen($payload), 0, $ip, $port);
	sdk_orvibo_debug("[".strtoupper(chunk_split(sdk_binary_to_string($payload), 2, ' '))."] sent to $all_one_ip, $port\n");
}

// read Orvibo data from UDP
function sdk_read_data($sock)
{
	$start = time();
	$timeout_sec = 15;
	socket_set_option($sock, SOL_SOCKET, SO_RCVTIMEO, array("sec" => $timeout_sec, "usec" => 0));
	
	while (time() - $start < $timeout_sec /*sec*/)
	{
		// Buffer len increased to support air conditionning remotes
		@$r = socket_recvfrom($sock, $buf, 2048, 0, $remote_ip, $remote_port);
		if ($buf != NULL)
		{
			sdk_orvibo_debug("[".trim(strtoupper(chunk_split(sdk_binary_to_string($buf), 2, ' ')))."] received from $remote_ip:$remote_port\n");
			
			$frame_type = strtoupper(substr(sdk_binary_to_string($buf), 8, 4));
			switch($frame_type)
			{
				case '6469':
					sdk_orvibo_debug("Button pressed\n");
				break;
				
				case '6C73':
					$ir_code = $frame_type = strtoupper(substr(sdk_binary_to_string($buf), 52));
					if ($ir_code != '')
					{
						sdk_show_header();
						$button_id = getArg('button_id');
						
						echo "IR code learned, saved to button #$button_id<br><br>";
						
						saveVariable('button'.$button_id, $ir_code);
						
						$query = $_GET;
						$query['action'] = 'setup';
						$query_string = http_build_query($query);
						echo "<a href='?".$query_string."'>Back to setup</a>";

						die();
					}
					else
					{
						sdk_orvibo_debug("learn ACK\n");
					}
				break;
				
				case '6963':
					sdk_orvibo_debug("IR emitted\n");
				break;
				
				case '636C':
					sdk_orvibo_debug("Subscription confirmation\n");
				break;
				
				case '7161':
					if (strpos(sdk_binary_to_string($buf), '495244') !== false)
					{
						$all_one_ip = $remote_ip;
						$all_one_mac = strtoupper(substr(sdk_binary_to_string($buf), 14, 12));
						sdk_orvibo_debug("This is an AllOne module ($all_one_ip)\n");
						
						if ($GLOBALS['action'] == 'scan')
						{
							sdk_show_header();
							echo ("Orvibo AllOne module found at IP address <b>$all_one_ip</b>, MAC address <b>$all_one_mac</b><br><br>\n");
							echo ("You can copy and paste those values on your eedomus Orvibo configuration.\n");
							die();
						}
						die();
					}
				break;
				
				default:
					sdk_orvibo_debug("Undecoded frame type [$frame_type]\n");
				break;
			}
		}
	}
	
	sdk_show_header();
	echo "Timeout, no IR received<br><br>";
	$query = $_GET;
	$query['action'] = 'setup';
	$query_string = http_build_query($query);
	echo "<a href='?".$query_string."'>Back to setup</a>";
}

socket_close($sock);
?>